%define anolis_release 1

Name:           libxmlb
Version:        0.3.15
Release:        %{anolis_release}%{?dist}
Summary:        Library for querying compressed XML metadata
License:        LGPL-2.1-or-later
URL:            https://github.com/hughsie/%{name}
Source0:        https://github.com/hughsie/%{name}/releases/download/%{version}/%{name}-%{version}.tar.xz

BuildRequires:  glib2-devel >= 2.45.8
BuildRequires:  gtk-doc
BuildRequires:  meson >= 0.47.0
BuildRequires:  gobject-introspection-devel
BuildRequires:  xz-devel
BuildRequires:  libzstd-devel
BuildRequires:  python3-setuptools
BuildRequires:  shared-mime-info

Requires:       glib2 >= 2.45.8
Requires:       shared-mime-info

%description
XML is slow to parse and strings inside the document cannot be memory mapped 
as they do not have a trailing NUL char. The libxmlb library takes XML source, 
and converts it to a structured binary representation with a deduplicated string 
table -- where the strings have the NULs included.

This allows an application to mmap the binary XML file, do an XPath query and return 
some strings without actually parsing the entire document. This is all done using 
(almost) zero allocations and no actual copying of the binary data.

%package devel
Summary:        Development package for %{name}
Requires:       %{name} = %{version}-%{release}

%description devel
Files for development with %{name}.

%package tests
Summary:        Files for installed tests

%description tests
Executable and data files for installed tests.

%package doc
Summary:        Documentation files for libxmlb
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The libxmlb-doc package contains documentation files for libxmlb.


%prep
%autosetup -p1

%build
%meson -Dgtkdoc=true -Dtests=true
%meson_build

%check
%meson_test

%install
%meson_install
%generate_compatibility_deps


%files
%license LICENSE
%dir %{abidir}
%{_bindir}/xb-tool
%{_mandir}/man1/xb-tool.1*
%dir %{_libdir}/girepository-1.0
%{_libdir}/girepository-1.0/Xmlb-2.0.typelib
%{_libdir}/libxmlb.so.2*
%{abidir}/libxmlb.dump
%{abidir}/xb-tool-option.list


%files devel
%dir %{_datadir}/gir-1.0
%{_datadir}/gir-1.0/Xmlb-2.0.gir
%dir %{_datadir}/gtk-doc
%dir %{_datadir}/gtk-doc/html
%{_datadir}/gtk-doc/html/libxmlb
%{_includedir}/libxmlb-2
%{_libdir}/libxmlb.so
%{_libdir}/pkgconfig/xmlb.pc

%files tests
%dir %{_libexecdir}/installed-tests/libxmlb
%{_libexecdir}/installed-tests/libxmlb/xb-self-test
%{_libexecdir}/installed-tests/libxmlb/test.*
%dir %{_datadir}/installed-tests/libxmlb
%{_datadir}/installed-tests/libxmlb/libxmlb.test

%files doc
%doc README.md

%changelog
* Tue Feb 25 2025 wangzhe <wanglan.wz@alibaba-inc.com> - 0.3.15-1
- Refer to CentOS Stream libxmlb-0.3.15-7 (tdawson@redhat.com)

* Thu Dec 28 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.3.11-3
- fix the source error

* Thu Apr 13 2023 chen_yu_ao <m15927509890@163.com> - 0.3.11-2
- change spec file format

* Thu Mar 02 2023 Funda Wang <fundawang@yeah.net> - 0.3.11-1
- New version 0.3.11

* Thu Dec 29 2022 Funda Wang <fundawang@yeah.net> - 0.3.10-1
- New version 0.3.10

* Wed Oct 19 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.3.6-2
- optimise spec file & add doc package

* Wed Mar 09 2022 Hongwei Qin <qhw01063182@alibaba-inc.com> - 0.3.6-1
- New upstream release
- Init for Anolis OS 23
